# wxMessageDialog Class Reference
[Common Dialogs]

`#include <wx/msgdlg.h>`

Inheritance diagram for wxMessageDialog:
[legend]

## Detailed Description

This class represents a dialog that shows a single or multi-line message, with a choice of OK, Yes, No and Cancel buttons.

## Styles

This class supports the following styles:

- wxOK:
  Puts an Ok button in the message box. May be combined with `wxCANCEL`.
- wxCANCEL:
  Puts a Cancel button in the message box. Must be combined with either `wxOK` or `wxYES_NO`.
- wxYES_NO:
  Puts Yes and No buttons in the message box. It is recommended to always use `wxCANCEL` with this style as otherwise the message box won't have a close button under wxMSW and the user will be forced to answer it.
- wxNO_DEFAULT:
  Makes the "No" button default, can only be used with `wxYES_NO`.
- wxCANCEL_DEFAULT:
  Makes the "Cancel" button default, can only be used with `wxCANCEL`
- wxYES_DEFAULT:
  Makes the "Yes" button default, this is the default behaviour and this flag exists solely for symmetry with `wxNO_DEFAULT`.
- wxOK_DEFAULT:
  Makes the "OK" button default, this is the default behaviour and this flag exists solely for symmetry with `wxCANCEL_DEFAULT`.
- wxICON_NONE:
  Displays no icon in the dialog if possible (an icon might still be displayed if the current platform mandates its use). This style may be used to prevent the dialog from using the default icon based on `wxYES_NO` presence as explained in `wxICON_QUESTION` and `wxICON_INFORMATION` documentation below.
- wxICON_EXCLAMATION:
  Displays an exclamation, or warning, icon in the dialog.
- wxICON_ERROR:
  Displays an error icon in the dialog.
- wxICON_HAND:
  Displays an error symbol, this is a MSW-inspired synonym for `wxICON_ERROR`.
- wxICON_QUESTION:
  Displays a question mark symbol. This icon is automatically used with `wxYES_NO` so it's usually unnecessary to specify it explicitly. This style is not supported for message dialogs under wxMSW when a task dialog is used to implement them (i.e. when running under Windows Vista or later) because Microsoft guidelines indicate that no icon should be used for routine confirmations. If it is specified, no icon will be displayed.
- wxICON_INFORMATION:
  Displays an information symbol. This icon is used by default if `wxYES_NO` is not given so it is usually unnecessary to specify it explicitly.
- wxSTAY_ON_TOP:
  Makes the message box stay on top of all other windows and not only just its parent (currently implemented only under MSW and GTK).
- wxCENTRE:
  Centre the message box on its parent or on the screen if parent is not specified. Setting this style under MSW makes no differences as the dialog is always centered on the parent.

##

Library: wxCore

Category: Common Dialogs

See also:
  wxMessageDialog Overview

  wxRichMessageDialog

## Public Member Functions
| wxMessageDialog (wxWindow *parent, const wxString &message, const wxString &caption=wxMessageBoxCaptionStr, long style=wxOK|wxCENTRE, const wxPoint &pos=wxDefaultPosition)
| Constructor specifying the message box properties.
virtual void | SetExtendedMessage (const wxString &extendedMessage)
| Sets the extended message for the dialog: this message is usually an extension of the short message specified in the constructor or set with SetMessage().
virtual void | SetMessage (const wxString &message)
| Sets the message shown by the dialog.
virtual bool | SetOKCancelLabels (const ButtonLabel &ok, const ButtonLabel &cancel)
| Overrides the default labels of the OK and Cancel buttons.
virtual bool | SetOKLabel (const ButtonLabel &ok)
| Overrides the default label of the OK button.
virtual bool | SetYesNoCancelLabels (const ButtonLabel &yes, const ButtonLabel &no, const ButtonLabel &cancel)
| Overrides the default labels of the Yes, No and Cancel buttons.
virtual bool | SetYesNoLabels (const ButtonLabel &yes, const ButtonLabel &no)
| Overrides the default labels of the Yes and No buttons.
virtual int | ShowModal ()
| Shows the dialog, returning one of wxID_OK, wxID_CANCEL, wxID_YES, wxID_NO.

List of all members.

## Constructor & Destructor Documentation

wxMessageDialog::wxMessageDialog | ( | wxWindow * | parent,
|  | const wxString & | message,
|  | const wxString & | caption = `wxMessageBoxCaptionStr`,
|  | long | style = `wxOK|wxCENTRE`,
|  | const wxPoint & | pos = `wxDefaultPosition` |
| ) |  |  |

Constructor specifying the message box properties.

Use ShowModal() to show the dialog.

style may be a bit list of the identifiers described above.

Notice that not all styles are compatible: only one of `wxOK` and `wxYES_NO` may be specified (and one of them must be specified) and at most one default button style can be used and it is only valid if the corresponding button is shown in the message box.

Parameters:

  | parent | Parent window.
  | message | Message to show in the dialog.
  | caption | The dialog title.
  | style | Combination of style flags described above.
  | pos | Dialog position (ignored under MSW).

## Member Function Documentation

virtual void wxMessageDialog::SetExtendedMessage | ( | const wxString & | extendedMessage | ) | `[virtual]`

Sets the extended message for the dialog: this message is usually an extension of the short message specified in the constructor or set with SetMessage().

If it is set, the main message appears highlighted -- if supported -- and this message appears beneath it in normal font. On the platforms which don't support extended messages, it is simply appended to the normal message with an empty line separating them.

Since:
  2.9.0

virtual void wxMessageDialog::SetMessage | ( | const wxString & | message | ) | `[virtual]`

Sets the message shown by the dialog.

Since:
  2.9.0

virtual bool wxMessageDialog::SetOKCancelLabels | ( | const ButtonLabel & | ok,
|  | const ButtonLabel & | cancel |
| ) |  |  | `[virtual]`

Overrides the default labels of the OK and Cancel buttons.

Please see the remarks in SetYesNoLabels() documentation.

Since:
  2.9.0

virtual bool wxMessageDialog::SetOKLabel | ( | const ButtonLabel & | ok | ) | `[virtual]`

Overrides the default label of the OK button.

Please see the remarks in SetYesNoLabels() documentation.

Since:
  2.9.0

virtual bool wxMessageDialog::SetYesNoCancelLabels | ( | const ButtonLabel & | yes,
|  | const ButtonLabel & | no,
|  | const ButtonLabel & | cancel |
| ) |  |  | `[virtual]`

Overrides the default labels of the Yes, No and Cancel buttons.

Please see the remarks in SetYesNoLabels() documentation.

Since:
  2.9.0

virtual bool wxMessageDialog::SetYesNoLabels | ( | const ButtonLabel & | yes,
|  | const ButtonLabel & | no |
| ) |  |  | `[virtual]`

Overrides the default labels of the Yes and No buttons.

The arguments of this function can be either strings or one of the standard identifiers, such as `wxID_APPLY` or `wxID_OPEN`. Notice that even if the label is specified as an identifier, the return value of the dialog ShowModal() method still remains one of `wxID_OK`, `wxID_CANCEL`, `wxID_YES` or `wxID_NO` values, i.e. this identifier changes only the label appearance but not the return code generated by the button. It is possible to mix stock identifiers and string labels in the same function call, for example:

            wxMessageDialog dlg(...);
            dlg.SetYesNoLabels(wxID_SAVE, _("&Don't save"));

Also notice that this function is not currently available on all platforms (although as of wxWidgets 2.9.0 it is implemented in all major ports), so it may return false to indicate that the labels couldn't be changed. If it returns true, the labels were set successfully.

Typically, if the function was used successfully, the main dialog message may need to be changed, e.g.:

            wxMessageDialog dlg(...);
            if ( dlg.SetYesNoLabels(_("&Quit"), _("&Don't quit")) )
                dlg.SetMessage(_("What do you want to do?"));
            else // buttons have standard "Yes"/"No" values, so rephrase the question
                dlg.SetMessage(_("Do you really want to quit?"));

Since:
  2.9.0

virtual int wxMessageDialog::ShowModal | ( |  | ) | `[virtual]`

Shows the dialog, returning one of wxID_OK, wxID_CANCEL, wxID_YES, wxID_NO.

Notice that this method returns the identifier of the button which was clicked unlike wxMessageBox() function.

Reimplemented from wxDialog.

|  | [ top ]